commit 732c68f17cb249e6d40727ab0a043ded0fed2247
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Sun Dec 14 12:52:18 2025 +0000

    socks module

diff --git a/src/scripts/Configure-Makefile b/src/scripts/Configure-Makefile
index 9b766d6ee..82e93d2ad 100755
--- a/src/scripts/Configure-Makefile
+++ b/src/scripts/Configure-Makefile
@@ -332,7 +332,7 @@ done <<-END
  routers    ROUTER	ACCEPT DNSLOOKUP IPLITERAL IPLOOKUP MANUALROUTE QUERYPROGRAM REDIRECT
  transports TRANSPORT	APPENDFILE AUTOREPLY LMTP PIPE QUEUEFILE SMTP
  auths	    AUTH	CRAM_MD5 CYRUS_SASL DOVECOT EXTERNAL GSASL HEIMDAL_GSSAPI PLAINTEXT SPA TLS
- miscmods   SUPPORT	ARC _DKIM DMARC DMARC_NATIVE DSCP _EXIM_FILTER PAM PERL RADIUS _SIEVE_FILTER SPF SPF_PERL
+ miscmods   SUPPORT	ARC _DKIM DMARC DMARC_NATIVE DSCP _EXIM_FILTER PAM PERL RADIUS _SIEVE_FILTER SOCKS SPF SPF_PERL
 END
 
 # See if there is a definition of EXIM_PERL in what we have built so far.
diff --git a/src/scripts/MakeLinks b/src/scripts/MakeLinks
index 35b58ec04..1875c6963 100755
--- a/src/scripts/MakeLinks
+++ b/src/scripts/MakeLinks
@@ -66,7 +66,7 @@ cd $d
 # Makefile is generated
 for f in README appendfile.h appendfile.c autoreply.h \
   autoreply.c lmtp.h lmtp.c pipe.h pipe.c queuefile.c queuefile.h \
-  smtp.h smtp.c smtp_socks.c tf_maildir.c tf_maildir.h
+  smtp.h smtp.c tf_maildir.c tf_maildir.h
 do
   ln -s ../../src/$d/$f $f
 done
@@ -108,6 +108,7 @@ for f in dummy.c \
 	perl.c perl_api.h \
 	radius.c radius_api.h \
 	sieve_filter.c sieve_filter_api.h \
+	socks.c socks_api.h \
 	spf.c spf_perl.c spf.h spf_api.h
 do
   ln -s ../../src/$d/$f `basename $f`
diff --git a/src/src/EDITME b/src/src/EDITME
index 98baae7d5..695cceafd 100644
--- a/src/src/EDITME
+++ b/src/src/EDITME
@@ -1131,7 +1131,7 @@ ZCAT_COMMAND=/usr/bin/zcat
 # Proxying.
 #
 # If you may want to use outbound (client-side) proxying, using Socks5,
-# uncomment the line below.
+# uncomment the line below.  To build as a dynamic module set it to 2.
 
 # SUPPORT_SOCKS=yes
 
diff --git a/src/src/drtables.c b/src/src/drtables.c
index e21d47047..3c714ba24 100644
--- a/src/src/drtables.c
+++ b/src/src/drtables.c
@@ -513,6 +513,9 @@ extern misc_module_info exim_filter_module_info;
 #if !defined(DISABLE_SIEVE_FILTER) && (!defined(SUPPORT_SIEVE_FILTER) || SUPPORT_SIEVE_FILTER!=2)
 extern misc_module_info sieve_filter_module_info;
 #endif
+#if defined(SUPPORT_SOCKS) && SUPPORT_SOCKS!=2
+extern misc_module_info socks_module_info;
+#endif
 
 void
 init_misc_mod_list(void)
@@ -537,9 +540,6 @@ onetime = TRUE;
 #if defined(SUPPORT_DSCP) && SUPPORT_DSCP!=2
   misc_mod_add(&dscp_module_info);
 #endif
-#if defined(RADIUS_CONFIG_FILE) && (!defined(SUPPORT_RADIUS) || SUPPORT_RADIUS!=2)
-  misc_mod_add(&radius_module_info);
-#endif
 #if defined(SUPPORT_PAM) && SUPPORT_PAM!=2
   misc_mod_add(&pam_module_info);
 #endif
@@ -552,6 +552,12 @@ onetime = TRUE;
 #if !defined(DISABLE_SIEVE_FILTER) && (!defined(SUPPORT_SIEVE_FILTER) || SUPPORT_SIEVE_FILTER!=2)
   misc_mod_add(&sieve_filter_module_info);
 #endif
+#if defined(SUPPORT_SOCKS) && SUPPORT_SOCKS!=2
+  misc_mod_add(&socks_module_info);
+#endif
+#if defined(RADIUS_CONFIG_FILE) && (!defined(SUPPORT_RADIUS) || SUPPORT_RADIUS!=2)
+  misc_mod_add(&radius_module_info);
+#endif
 }
 
 
diff --git a/src/src/exim.c b/src/src/exim.c
index 383fe8247..e955d2488 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -3093,6 +3093,8 @@ on the second character (the one after '-'), to save some effort. */
 
 #ifdef SUPPORT_SOCKS
     /* -MCp: Socks proxy in use; nearside IP, port, external IP, port */
+    /*XXX Neatness might have this code in the socks module, but having to
+    load a dynamic version puely for this?  However, of logging moved there...*/
 	case 'p': proxy_session = TRUE;
 		  if (++i < argc)
 		    {
diff --git a/src/src/exim.h b/src/src/exim.h
index 07b017a01..4bd0a87e7 100644
--- a/src/src/exim.h
+++ b/src/src/exim.h
@@ -570,6 +570,9 @@ config.h, mytypes.h, and store.h, so we don't need to mention them explicitly.
 #ifdef EXIM_PERL
 # include "miscmods/perl_api.h"
 #endif
+#ifdef SUPPORT_SOCKS
+# include "miscmods/socks_api.h"
+#endif
 #include "miscmods/exim_filter_api.h"
 #include "miscmods/sieve_filter_api.h"
 
diff --git a/src/src/miscmods/Makefile b/src/src/miscmods/Makefile
index e129fe8bc..a5fbba441 100644
--- a/src/src/miscmods/Makefile
+++ b/src/src/miscmods/Makefile
@@ -48,6 +48,7 @@ pam.o   pam.so:			$(HDRS) pam.c
 perl.o perl.so:         	$(HDRS) perl.c
 radius.o radius.so:		$(HDRS) radius.c
 sieve_filter.o sieve_filter.so:	$(HDRS) sieve_filter.c
+socks.o socks.so:		$(HDRS) socks_api.h ../transports/smtp.h socks.c
 spf.o   spf.so:			$(HDRS) spf.h spf.c
 spf_perl.o spf_perl.so:		$(HDRS) spf.h spf_perl.c
 
diff --git a/src/src/transports/smtp_socks.c b/src/src/miscmods/socks.c
similarity index 94%
rename from src/src/transports/smtp_socks.c
rename to src/src/miscmods/socks.c
index c17b808e9..6694044da 100644
--- a/src/src/transports/smtp_socks.c
+++ b/src/src/miscmods/socks.c
@@ -10,15 +10,10 @@
 /* SOCKS version 5 proxy, client-mode */
 
 #include "../exim.h"
-#include "smtp.h"
+#include "../transports/smtp.h"
 
 #ifdef SUPPORT_SOCKS /* entire file */
 
-#ifndef nelem
-# define nelem(arr) (sizeof(arr)/sizeof(*arr))
-#endif
-
-
 /* Defaults */
 #define SOCKS_PORT	1080
 #define SOCKS_TIMEOUT	5
@@ -187,18 +182,18 @@ return -1;
 
 
 
-/* Make a connection via a socks proxy
+/*API: Make a connection via a socks proxy
 
 Arguments:
  sc		details for making connection: host, af, interface, transport
  early_data	data to send down the smtp channel (once proxied)
 
 Return value:
- 0 on success; -1 on failure, with errno set
+ connected file descriptor on success; -1 on failure, with errno set
 */
 
-int
-socks_sock_connect(smtp_connect_args * sc, const blob * early_data)
+static int
+socks_sock_connect(const smtp_connect_args * sc, const blob * early_data)
 {
 transport_instance * tb = sc->tblock;
 smtp_transport_options_block * ob = tb->drinst.options_block;
@@ -407,6 +402,24 @@ rcv_err:
   return -1;
 }
 
+/******************************************************************************/
+/* Module API */
+
+static void * socks_functions[] = {
+  [SOCKS_CONNECT] =	(void *) socks_sock_connect,
+};
+
+misc_module_info socks_module_info =
+{
+  .name =		US"socks",
+# ifdef DYNLOOKUP
+  .dyn_magic =		MISC_MODULE_MAGIC,
+# endif
+
+  .functions =		socks_functions,
+  .functions_count =	nelem(socks_functions),
+};
+
 #endif	/* entire file */
 /* vi: aw ai sw=2
 */
diff --git a/src/src/miscmods/socks_api.h b/src/src/miscmods/socks_api.h
new file mode 100644
index 000000000..6a083d3cb
--- /dev/null
+++ b/src/src/miscmods/socks_api.h
@@ -0,0 +1,14 @@
+/*************************************************
+*     Exim - an Internet mail transport agent    *
+*************************************************/
+
+/* Copyright (c) The Exim Maintainers 2025 */
+/* See the file NOTICE for conditions of use and distribution. */
+/* SPDX-License-Identifier: GPL-2.0-or-later */
+
+/* API definitions for the socks module */
+
+
+/* Function table entry numbers */
+
+#define	SOCKS_CONNECT	0
diff --git a/src/src/smtp_out.c b/src/src/smtp_out.c
index 790a0c005..a5557d09e 100644
--- a/src/src/smtp_out.c
+++ b/src/src/smtp_out.c
@@ -520,7 +520,12 @@ if (ob->socks_proxy)
     return -1;
     }
   if (*ob->socks_proxy)
-    return socks_sock_connect(sc, early_data);
+    {
+    uschar * dummy_errmsg;
+    misc_module_info * mi = misc_mod_find(US"socks", &dummy_errmsg);
+    typedef int (*fn_t) (const smtp_connect_args *, const blob *);
+    return mi ? ((fn_t *) mi->functions)[SOCKS_CONNECT] (sc, early_data) : -1;
+    }
   }
 #endif
 
diff --git a/src/src/transports/Makefile b/src/src/transports/Makefile
index 89cadc568..761cf01c8 100644
--- a/src/src/transports/Makefile
+++ b/src/src/transports/Makefile
@@ -11,12 +11,12 @@
 
 # MAGIC-TAG-MODS-OBJ-RULES-GO-HERE
 
-OBJ += smtp_socks.o tf_maildir.o
+OBJ += tf_maildir.o
 
 all:	transports.a $(MODS)
 	$(FE):
 
-transports.a:    $(OBJ) smtp_socks.o tf_maildir.o
+transports.a:    $(OBJ) tf_maildir.o
 		 @$(RM_COMMAND) -f transports.a
 		 @echo "$(AR) transports.a"
 		 @$(AR) transports.a $(OBJ)
@@ -39,7 +39,6 @@ lmtp.o lmtp.so:			lmtp.c lmtp.h
 pipe.o pipe.so:			pipe.c pipe.h
 queuefile.o queuefile.so:	queuefile.c queuefile.h
 smtp.o:				smtp.c smtp.h
-smtp_socks.o:			smtp_socks.c smtp.h
 
 tf_maildir.o:			tf_maildir.c tf_maildir.h appendfile.h
 
diff --git a/src/src/transports/smtp.h b/src/src/transports/smtp.h
index 506d6094a..72b3b00ba 100644
--- a/src/src/transports/smtp.h
+++ b/src/src/transports/smtp.h
@@ -250,9 +250,4 @@ extern BOOL smtp_transport_entry(transport_instance *, address_item *);
 extern void smtp_transport_closedown(transport_instance *);
 
 
-
-#ifdef SUPPORT_SOCKS
-extern int     socks_sock_connect(smtp_connect_args *, const blob *);
-#endif
-
 /* End of transports/smtp.h */

